<?php
if(!isset($GLOBALS['sms_dostep_prefix'])) die('Nie zdefiniowano sms_dostep_prefix');
if(!isset($GLOBALS['sms_dostep_klucz'])) die('Nie zdefiniowano sms_dostep_klucz');
if(!isset($GLOBALS['sms_dostep_kodowanie'])) $GLOBALS['sms_dostep_kodowanie'] = 'utf';
if(!isset($GLOBALS['sms_dostep_test'])) $GLOBALS['sms_dostep_test'] = 1;

function sms_dostep_safestr($s) {
	return preg_replace('/[^a-zA-Z0-9]/','-',$s);
}

function sms_valid_codes($tariff, $mode, $time, $zone, $pass) {
	$tcodes = array();
	$tmds = array('D' => 86400, 'H' => 3600, 'M' => 60);
	$tmd = $tmds[$mode];
	for($n = 0; $n <= $time; $n++) {
		$tv = floor((time() - $n * $tmd) / $tmd);
		$timehash = strtoupper(substr(md5($tv.$tariff.$zone.$GLOBALS['sms_dostep_klucz']),0,4));
		$resphash = strtoupper(substr(md5($mode.$timehash.$GLOBALS['sms_dostep_klucz']),0,6));
		
		$codehash = strtoupper(md5($resphash));
		$tdiff = array();
		for($i = 0; $i < 6; $i++) {
			$tdiff[$i] = ord($resphash[$i]) ^ ord($pass[$i]);
		}
		//$tdiff[] = $resphash;
		$tcodes["C{$codehash}"] = $tdiff;
	}
	return $tcodes;
}

function sms_dostep_encrypt($str, $pwd) {
	$bstr = base64_encode($str);
	$hpwd = md5($pwd);

	$enc = '';
	$lkey = strlen($hpwd);
	for($n = 0; $n < strlen($bstr); $n++) {
		$enc .= $bstr[$n] ^ $hpwd[$n % $lkey];
	}
	$enc = base64_encode($enc);
	return $enc;
}

function sms_dostep_form($zone, $title) {
	$html = "
<style type='text/css'>
#atomsms { width: 400px; background: #f0f0f0; margin: auto; text-align: left; border: 1px solid silver; padding: 10px 20px; background: white; }
#atomsms * { font-family: verdana,sans-serif; font-size: 12px; color: #444; }
#atomsms h1 { font-family: \"Trebuchet MS\",sans-serif; font-size: 27px; font-weight: normal; color: #47a; margin: 0 0 15px 0; text-align: center; }
#atomsms p { margin: 4px 0 0 0; clear: both; }
#atomsms .premium { border-left: 6px solid #BF1A16; background: #F6F6F6; margin: 5px 0 15px 0; padding: 6px; width: 380px; }
#atomsms p.conn { margin: 20px 0 20px 0; text-align: center; }
#atomsms p.foot { margin-top: 30px; text-align: center; }
#atomsms p.foot img { margin: 5px; }
#atomsms .err { font-weight: bold; color: red; }
</style>
<div id='atomsms'>
<form name='code' action='{$_SERVER['REQUEST_URI']}' method='post'>
<h1>Strefa płatna</h1>
<p>Artykuł <strong>$title</strong> należy do strefy płatnej, do której wejście wymaga wysłania SMSa.</p>";
	foreach($GLOBALS['sms-access-tariff'] as $onetariff) {
		preg_match('/^([0-9]{1,2})(D|H|M)(.*)$/i', $onetariff, $regs);
		list($foo, $tariff, $mode, $time) = $regs;
		$mode = strtoupper($mode);
		switch($mode) {
			case 'D': $tv = floor(time() / 86400); $tn = 'dni'; break;
			case 'H': $tv = floor(time() / 3600); $tn = 'godzin'; break;
			case 'M': $tv = floor(time() / 60); $tn = 'minut'; break;
		}
		$h = md5($GLOBALS['sms_dostep_prefix'].$tariff.$mode.$tv.$zone.$GLOBALS['sms_dostep_test'].$GLOBALS['sms_dostep_klucz']);
		$pars = "p={$GLOBALS['sms_dostep_prefix']}&amp;r={$tariff}&amp;i=msg-{$onetariff}&amp;m={$mode}&amp;t={$tv}&amp;f={$zone}&amp;s={$GLOBALS['sms_dostep_test']}&amp;h=$h&amp;c={$GLOBALS['sms_dostep_kodowanie']}";
		$html .= "\n<p>Dostęp na czas <b>{$time} {$tn}</b>:</p>\n";
		$html .= "<div class='premium'>\n";
		$html .= "<div id='msg-$onetariff'><p class='conn'>Łączenie z serwerem, proszę czekać...</p></div>\n";
		$html .= "<script type='text/javascript' src=\"https://app.atomsms.pl/sms-access.php?$pars\"></script>\n";
		$html .= "</div>\n";
	}
	if(isset($GLOBALS['sms-access-err'])) $html .= "<p class='err'>{$GLOBALS['sms-access-err']}</p>\n";
	$html .= "
<p align='center'>
Tu wpisz kod otrzymany SMSem:<br />
<input type='text' name='txtcode' />
<button type='button' onclick=\"return asfchk(this.form.txtcode.value, true)\">Wejdź</button>
</p>
</form>
<p class='foot'>Płatności SMS obsługuje<br /><a target='_blank' href='https://www.atomsms.pl/' title='Dostęp SMS'><img width='120' height='23' alt='Dostęp SMS' src='https://www.atomsms.pl/img/logo120x23.png' border='0' /></a></p>
<script>ascc()</script>
</div>
";
	//header('Content-Type: text/html; charset='.sms_dostep_enc());
	return sms_dostep_encode($html);
}
function sms_dostep_enc() {
	switch($GLOBALS['sms_dostep_kodowanie']) {
		case 'iso': return 'iso-8859-2';
		case 'win': return 'windows-1250';
		default: return 'utf-8';
	}
}
function sms_dostep_encode($s) {
	switch($GLOBALS['sms_dostep_kodowanie']) {
		case 'iso':
			$enctab = array(
				'ą'=>'','ć'=>'','ę'=>'','ł'=>'','ń'=>'','ó'=>'','ś'=>'','ż'=>'','ź'=>'',
				'Ą'=>'','Ć'=>'','Ę'=>'','Ł'=>'','Ń'=>'','Ó'=>'','Ś'=>'','Ż'=>'','Ź'=>'');
			return strtr($s, $enctab);
		case 'win':
			$enctab = array(
				'ą'=>'','ć'=>'','ę'=>'','ł'=>'','ń'=>'','ó'=>'','ś'=>'','ż'=>'','ź'=>'',
				'Ą'=>'','Ć'=>'','Ę'=>'','Ł'=>'','Ń'=>'','Ó'=>'','Ś'=>'','Ż'=>'','Ź'=>'');
			return strtr($s, $enctab);
		default:
			return $s;
	}
}
?>